require 'json'

module Axon
	class AxonMsg
		KEY_ERROR = "_error"
		def self.parse(msg_s)
			msg_o = JSON.parse(msg_s)
			AxonMsg.new(msg_o, msg_o[KEY_ERROR])
		end
		def initialize(data = {}, error = nil)
			raise "data must be a hash" unless data.is_a? Hash
			@data = data
			@data[KEY_ERROR] = error unless error.nil?
		end
		def [](key)
			@data[key.to_s]
		end
		def []=(key, value)
			@data[key.to_s] = value
		end
		def error?
			!@data[KEY_ERROR].nil?
		end
		def to_s
			JSON.generate(@data)
		end
		def to_str
			to_s
		end
		def method_missing(method, *args)
			@data.send(method, *args) if @data.respond_to? method
		end
	end
end
